package de.intevation.flys.client.shared.model;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;


/**
 * The default implementation of a {@link Collection}.
 *
 * @author <a href="mailto:ingo.weinzierl@intevation.de">Ingo Weinzierl</a>
 */
public class DefaultCollection implements Collection {

    /** The uuid of the collection. */
    protected String uuid;

    /** The list of artifacts that are managed by this Collection.*/
    protected List<Artifact> artifacts;


    /**
     * Creates a new DefaultCollection with a UUID.
     *
     * @param uuid The UUID.
     */
    public DefaultCollection(String uuid) {
        this.uuid      = uuid;
        this.artifacts = new ArrayList<Artifact>();
    }


    public String identifier() {
        return uuid;
    }


    public Date getLastAccess() {
        return new Date();
    }


    public String getName() {
        return uuid;
    }


    public void addArtifact(Artifact artifact) {
        if (artifact != null) {
            artifacts.add(artifact);
        }
    }


    public int getArtifactLength() {
        return artifacts.size();
    }


    public Artifact getArtifact(int idx) {
        return artifacts.get(idx);
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
